-file("/usr/lib/erlang/lib/parsetools-2.0.6/include/leexinc.hrl", 0).
%% The source of this file is part of leex distribution, as such it
%% has the same Copyright as the other files in the leex
%% distribution. The Copyright is defined in the accompanying file
%% COPYRIGHT. However, the resultant scanner generated by leex is the
%% property of the creator of the scanner and is not covered by that
%% Copyright.

-module(egs_script_lexer).

-export([string/1,string/2,token/2,token/3,tokens/2,tokens/3]).
-export([format_error/1]).

%% User code. This is placed here to allow extra attributes.
-file("src/egs_script_lexer.xrl", 46).

%% Reserved words.
reserved_word("debug")    -> debug;
%% Definitions.
reserved_word("event")    -> event_def;
reserved_word("function") -> function_def;
reserved_word("num_var")  -> num_var;
reserved_word("str_var")  -> str_var;
%% Low level opcodes.
reserved_word("abs")      -> abs;
reserved_word("add")      -> add;
reserved_word("band")     -> 'band';
reserved_word("bor")      -> 'bor';
reserved_word("bxor")     -> 'bxor';
reserved_word("dec")      -> dec;
reserved_word("div")      -> 'div';
reserved_word("inc")      -> inc;
reserved_word("is_eq")    -> is_eq;
reserved_word("is_gt")    -> is_gt;
reserved_word("is_gteq")  -> is_gteq;
reserved_word("is_lt")    -> is_lt;
reserved_word("is_lteq")  -> is_lteq;
reserved_word("is_neq")   -> is_neq;
reserved_word("jmp")      -> jmp;
reserved_word("jnz")      -> jnz;
reserved_word("jz")       -> jz;
reserved_word("land")     -> land;
reserved_word("lor")      -> lor;
reserved_word("lshift")   -> lshift;
reserved_word("mod")      -> mod;
reserved_word("mul")      -> mul;
reserved_word("neg")      -> neg;
reserved_word("nop")      -> nop;
reserved_word("num_get")  -> num_get;
reserved_word("num_set")  -> num_set;
reserved_word("push")     -> push;
reserved_word("restore")  -> restore;
reserved_word("return")   -> return;
reserved_word("rshift")   -> rshift;
reserved_word("save")     -> save;
reserved_word("savep")    -> savep;
reserved_word("str_get")  -> str_get;
reserved_word("str_set")  -> str_set;
reserved_word("sub")      -> sub;
%% Case statement.
reserved_word("case")     -> 'case';
reserved_word("default")  -> default;
reserved_word("end")      -> 'end';
%% Otherwise isn't a reserved word.
reserved_word(_)          -> false.

%% Syscalls.
syscall("mes.fukidasi_pc")                  -> {100,  sync};
syscall("mes.fukidasi_apc")                 -> {101,  sync};
syscall("mes.fukidasi_npc")                 -> {102,  sync};
syscall("mes.fukidasi_pc_type")             -> {103,  sync};
syscall("mes.fukidasi_apc_type")            -> {104,  sync};
syscall("mes.fukidasi_npc_type")            -> {105,  sync};
syscall("mes.fukidasi_custom")              -> {106,  sync};
syscall("mes.erase_fukidasi")               -> {107, async};
syscall("mes.chat_pc")                      -> {108, async};
syscall("mes.cut_in_chat")                  -> {109, async};
syscall("mes.cut_in_chat_custom")           -> {110, async};
syscall("mes.system_win")                   -> {111,  sync};
syscall("mes.custom_win")                   -> {112,  sync};
syscall("mes.scroll_win")                   -> {113,  sync};
syscall("mes.win_move")                     -> {114, async};
syscall("mes.erase_system_win")             -> {115, async};
syscall("mes.select_win")                   -> {116,  sync};
syscall("mes.select_win_set")               -> {117,  sync};
syscall("mes.select_win_single")            -> {118,  sync};
syscall("mes.select_win_custom")            -> {119,  sync};
syscall("mes.select_win_fukidasi")          -> {120,  sync};
syscall("mes.select_win_b")                 -> {121,  sync};
syscall("mes.select_win_set_b")             -> {122,  sync};
syscall("mes.select_win_single_b")          -> {123,  sync};
syscall("mes.select_win_custom_b")          -> {124,  sync};
syscall("mes.select_win_fukidasi_b")        -> {125,  sync};
syscall("mes.erase_select_win")             -> {126,  sync};
syscall("mes.message_end")                  -> {127, async};
syscall("mes.set_name_npc")                 -> {128, async};
syscall("mes.set_color_npc")                -> {129, async};
syscall("mes.line_window")                  -> {130, async};
syscall("adv.cut_in")                       -> {131, async};
syscall("adv.cut_in_custom")                -> {132, async};
syscall("adv.window_disable")               -> {133, async};
syscall("adv.window_enable")                -> {134, async};
syscall("adv.fukidasi_disable")             -> {135, async};
syscall("adv.fukidasi_enable")              -> {136, async};
syscall("adv.player_disable")               -> {137, async};
syscall("adv.player_enable")                -> {138, async};
syscall("adv.chat_on")                      -> {139, async};
syscall("adv.chat_off")                     -> {140, async};
syscall("adv.mainmenu_disable")             -> {141, async};
syscall("adv.mainmenu_enable")              -> {142, async};
syscall("unit_flag.on")                     -> {143, async};
syscall("unit_flag.off")                    -> {144, async};
syscall("unit_flag.reverse")                -> {145, async};
syscall("unit_flag.delay_on")               -> {146, async};
syscall("unit_flag.delay_off")              -> {147, async};
syscall("unit_flag.delay_reverse")          -> {148, async};
syscall("unit_flag.chk")                    -> {149, async};
syscall("player.get_my_id")                 -> {150, async};
syscall("player.set_pos")                   -> {151, async};
syscall("player.change_unit")               -> {152, async};
syscall("player.turn")                      -> {153, async};
syscall("player.walk")                      -> {154, async};
syscall("player.run")                       -> {155, async};
syscall("player.pad_off")                   -> {158, async};
syscall("player.pad_on")                    -> {159, async};
syscall("player.get_pos")                   -> {160, async};
syscall("player.get_ang")                   -> {161, async};
syscall("player.turn_coord")                -> {162, async};
syscall("player.turn_member")               -> {163, async};
syscall("plymotion.item_take_off")          -> {173, async};
syscall("plymotion.set_pack")               -> {174,  sync};
syscall("plymotion.release_pack")           -> {176, async};
syscall("plymotion.set_loop")               -> {177, async};
syscall("plymotion.play_one_shot")          -> {178,  sync};
syscall("plymotion.cancel_one_shot")        -> {179, async};
syscall("plymotion.restart_one_shot")       -> {180, async};
syscall("apc.create")                       -> {183,  sync};
syscall("apc.delete")                       -> {184, async};
syscall("apc.delete_inx")                   -> {185, async};
syscall("apc.team_into")                    -> {186, async};
syscall("apc.team_remove")                  -> {187, async};
syscall("apc.set_pos")                      -> {188, async};
syscall("apc.turn")                         -> {189, async};
syscall("apc.walk")                         -> {190, async};
syscall("apc.run")                          -> {191, async};
syscall("apc.think_off")                    -> {194, async};
syscall("apc.think_on")                     -> {195, async};
syscall("apc.get_pos")                      -> {196, async};
syscall("apc.get_ang")                      -> {197, async};
syscall("apc.reserve")                      -> {205, async};
syscall("apc.reserve_cancel")               -> {206, async};
syscall("apc.is_reserve")                   -> {207, async};
syscall("apc.create_lv")                    -> {208,  sync};
syscall("apc.reserve_lv")                   -> {209, async};
syscall("apc.target_guard")                 -> {210, async};
syscall("apc.target_guard_pid")             -> {211, async};
syscall("apc.target_guard_aid")             -> {212, async};
syscall("apc.cancel_target_guard")          -> {213, async};
syscall("apc.set_move_out_party")           -> {214, async};
syscall("apc.apc_set_ban")                  -> {215, async};
syscall("apc.get_aid_from_pid")             -> {216, async};
syscall("apc.is_apc2")                      -> {217, async};
syscall("apc.is_alive")                     -> {218, async};
syscall("camera.set")                       -> {219, async};
syscall("camera.move")                      -> {220, async};
syscall("camera.release")                   -> {221, async};
syscall("camera.get_pos")                   -> {222, async};
syscall("camera.cam_rot")                   -> {223, async};
syscall("camera.target_rot")                -> {224, async};
syscall("camera.dist_move")                 -> {225, async};
syscall("camera.get_cam_angle")             -> {226, async};
syscall("camera.get_target_angle")          -> {227, async};
syscall("camera.get_dist")                  -> {228, async};
syscall("camera.set_quake")                 -> {229, async};
syscall("camera.stop_quake")                -> {230, async};
syscall("direction.fade_in")                -> {232, async};
syscall("direction.fade_out")               -> {233, async};
syscall("direction.fade_out_rgba")          -> {234, async};
syscall("direction.cinema_on")              -> {235, async};
syscall("direction.cinema_off")             -> {236, async};
syscall("direction.vib")                    -> {237, async};
syscall("wait.abort_cancel")                -> {238, async};
syscall("temp.exit_game")                   -> {239, async};
syscall("movie.play_prm")                   -> {240,  sync};
syscall("movie.play_rtm")                   -> {242,  sync};
syscall("movie.play_event")                 -> {245,  sync};
syscall("movie.play_sub_title")             -> {246,  sync};
syscall("movie.telop")                      -> {247,  sync};
syscall("sound.play_se")                    -> {251, async};
syscall("sound.play_bgm")                   -> {253, async}; %% Unofficial name.
syscall("sound.stop_bgm")                   -> {256, async};
syscall("render.scene_off")                 -> {257, async};
syscall("render.scene_on")                  -> {258, async};
syscall("render.npc_all_off")               -> {259, async};
syscall("render.npc_all_on")                -> {260, async};
syscall("render.npc_off")                   -> {261, async};
syscall("render.npc_on")                    -> {262, async};
syscall("render.player_off")                -> {263, async};
syscall("render.player_on")                 -> {264, async};
syscall("render.enemy_off")                 -> {265, async};
syscall("render.enemy_on")                  -> {266, async};
syscall("render.obj_off")                   -> {267, async};
syscall("render.obj_on")                    -> {268, async};
syscall("seq.get_quest")                    -> {271, async};
syscall("seq.is_online")                    -> {272, async};
syscall("seq.save_qst")                     -> {273,  sync};
syscall("seq.get_area")                     -> {274, async};
syscall("seq.get_zone")                     -> {275, async};
syscall("seq.get_unit")                     -> {276, async};
syscall("seq.get_item")                     -> {280,  sync};
syscall("work.accountwork_get")             -> {282,  sync};
syscall("work.accountwork_set")             -> {283,  sync};
syscall("work.chrwork_get")                 -> {284,  sync};
syscall("work.chrwork_set")                 -> {285,  sync};
syscall("work.chrflag_get")                 -> {286,  sync};
syscall("work.chrflag_set")                 -> {287,  sync};
syscall("work.partyflag_on")                -> {288,  sync};
syscall("work.partyflag_off")               -> {289,  sync};
syscall("work.qstwork_get")                 -> {290, async};
syscall("work.qstwork_get_member")          -> {291, async};
syscall("work.qstwork_set")                 -> {292, async};
syscall("work.partyflag_get")               -> {297, async};
syscall("work.partywork_get")               -> {298, async};
syscall("work.partywork_set")               -> {299, async};
syscall("work.zone_cndflag_get")            -> {300, async};
syscall("work.zone_cndflag_on")             -> {301, async};
syscall("work.zone_cndflag_off")            -> {302, async};
syscall("work.zone_sendwork_get")           -> {303, async};
syscall("work.zone_sendwork_set")           -> {304, async};
syscall("work.party_rand_get")              -> {305,  sync};
syscall("party.get_member")                 -> {306, async};
syscall("party.get_leader")                 -> {307, async};
syscall("party.chk_exist")                  -> {308, async};
syscall("party.sync_wait")                  -> {309,  sync};
syscall("party.join_on")                    -> {310, async};
syscall("party.join_off")                   -> {311, async};
syscall("party.get_enemy_kill")             -> {312, async};
syscall("ptcl.create")                      -> {315, async};
syscall("ptcl.move")                        -> {316, async};
syscall("ptcl.delete")                      -> {317, async};
syscall("col.create")                       -> {318, async};
syscall("col.create_lock_on")               -> {319, async};
syscall("col.create_attack")                -> {320, async};
syscall("col.move")                         -> {321, async};
syscall("col.scale")                        -> {322, async};
syscall("col.delete")                       -> {323, async};
syscall("npc.talk_on")                      -> {324, async};
syscall("npc.talk_off")                     -> {325, async};
syscall("npc.think_on")                     -> {326, async};
syscall("npc.think_off")                    -> {327, async};
syscall("npc.set_pos")                      -> {328, async};
syscall("npc.turn")                         -> {329, async};
syscall("npc.gaze")                         -> {330, async};
syscall("npc.walk")                         -> {331, async};
syscall("npc.run")                          -> {332, async};
syscall("npc.walk_path")                    -> {335, async};
syscall("npc.run_path")                     -> {336, async};
syscall("npc.get_pos")                      -> {338, async};
syscall("npc.get_ang")                      -> {339, async};
syscall("npc.cng_motion")                   -> {340, async};
syscall("npc.cancel_motion")                -> {341, async};
syscall("npc.get_motion")                   -> {342, async};
syscall("npc.coli_end")                     -> {343, async};
syscall("obj.coli_end")                     -> {347, async}; %% Unofficial name.
syscall("status.get_posflag")               -> {354, async};
syscall("lobby.start")                      -> {356,  sync};
syscall("lobby.end")                        -> {357, async};
syscall("lobby.select_planet")              -> {358,  sync};
syscall("camera.def_cng")                   -> {359, async};
syscall("camera.def_remove")                -> {360, async};
syscall("camera.def_move_back")             -> {361, async};
syscall("camera.def_set_back")              -> {362, async};
syscall("camera.def_set_quake")             -> {364, async};
syscall("camera.def_stop_qake")             -> {365, async};
syscall("calc.get_rot")                     -> {373, async};
syscall("sjis.fukidasi_pc")                 -> {389,  sync};
syscall("sjis.fukidasi_apc")                -> {390,  sync};
syscall("sjis.fukidasi_npc")                -> {391,  sync};
syscall("sjis.fukidasi_pc_type")            -> {392,  sync};
syscall("sjis.fukidasi_apc_type")           -> {393,  sync};
syscall("sjis.fukidasi_npc_type")           -> {394,  sync};
syscall("sjis.fukidasi_custom")             -> {395,  sync};
syscall("sjis.chat_pc")                     -> {396, async};
syscall("sjis.cut_in_chat")                 -> {397, async};
syscall("sjis.cut_in_chat_custom")          -> {398, async};
syscall("sjis.system_win")                  -> {399,  sync};
syscall("sjis.custom_win")                  -> {400,  sync};
syscall("sjis.scroll_win")                  -> {401,  sync};
syscall("sjis.select_win")                  -> {402,  sync};
syscall("sjis.select_win_set")              -> {403,  sync};
syscall("sjis.select_win_single")           -> {404,  sync};
syscall("sjis.select_win_custom")           -> {405,  sync};
syscall("sjis.select_win_fukidasi")         -> {406,  sync};
syscall("sjis.select_win_b")                -> {407,  sync};
syscall("sjis.select_win_set_b")            -> {408,  sync};
syscall("sjis.select_win_single_b")         -> {409,  sync};
syscall("sjis.select_win_custom_b")         -> {410,  sync};
syscall("sjis.select_win_fukidasi_b")       -> {411,  sync};
syscall("sjis.line_window")                 -> {412, async};
syscall("temp.line")                        -> {413, async};
syscall("temp.sline")                       -> {414, async};
syscall(_)                                  -> false.

%% Functions.
function("adv.cut_in_load")                 -> {"q.adv.cut_in_load",              async};
function("adv.cut_in_noise")                -> {"q.adv.cut_in_noise",             async};
function("adv.cut_in_release")              -> {"q.adv.cut_in_release",           async};
function("adv.cut_in_stop")                 -> {"q.adv.cut_in_stop",              async};
%% @todo apc.apc_sp_exec
%% @todo q.apc.create_ex
function("apc.get_reserve_aid_all")         -> {"apc.get_reserve_aid_all",        async};
function("apc.get_reserve_count")           -> {"apc.get_reserve_count",          async};
function("apc.guildcard_disable")           -> {"apc.guildcard_disable",          async};
function("apc.guildcard_enable")            -> {"apc.guildcard_enable",           async};
function("apc.impossible_join_pt")          -> {"apc.impossible_join_pt",         async};
function("apc.is_set_ban")                  -> {"apc.is_set_ban",                 async};
%% @todo apc.move
%% @todo apc.move_xz
function("apc.possible_join_pt")            -> {"apc.possible_join_pt",           async};
%% @todo apc.set_goal_out_party
function("apc.set_sp_ban")                  -> {"apc.set_sp_ban",                 async};
function("apc.set_talk_ban")                -> {"apc.set_talk_ban",               async};
function("counter.create_dc_map")           -> {"counter.create_dc_map",          async};
function("counter.delete_dc_map")           -> {"counter.delete_dc_map",          async};
function("counter.set_arrow_pos")           -> {"counter.set_arrow_pos",          async};
function("counter.set_lookon_pos")          -> {"counter.set_lookon_pos",         async};
function("direction.fade_out_nowloading")   -> {"direction.fade_out_nowloading",  async};
function("font.set_party_member_id")        -> {"font.set_party_member_id",       async};
function("item.exchange")                   -> {"q.seq.exchange_item",             sync};
function("item.get_num")                    -> {"q.seq.get_item_num",              sync};
function("item.get_slot_num_req")           -> {"q.item.get_slot_num_req",         sync};
function("item.get_slot_num_ret")           -> {"q.item.get_slot_num_ret",        async};
%% @todo item.set_ability
function("mes.mes_broadcast_clear")         -> {"mes.mes_broadcast_clear",        async};
%% @todo mes.mes_broadcast_clear_all
function("mes.mes_broadcast_set")           -> {"mes.mes_broadcast_set",          async};
function("mes.line_window_time")            -> {"q.mes.line_window_line_time",    async};
function("mes.select_win_number")           -> {"q.mes.select_win_number",         sync};
function("movie.text_prm_delay")            -> {"movie.text_prm_delay",           async};
function("myroom.check_data_load")          -> {"myroom.check_data_load",         async};
function("myroom.disable_obj_ex")           -> {"myroom.disable_obj_ex",          async};
function("myroom.get_move_planet")          -> {"myroom.get_move_planet",         async};
function("myroom.get_probo_ang")            -> {"myroom.get_probo_ang",           async};
function("myroom.get_probo_pos")            -> {"myroom.get_probo_pos",           async};
function("myroom.get_probo_rank")           -> {"myroom.get_probo_rank",          async};
function("myroom.news_enable")              -> {"myroom.news_enable",             async};
%% @todo myroom.get_probo_type
function("npc.gaze_cancel")                 -> {"npc.gaze_cancel",                async};
%% @todo npc.get_head_y
function("npc.is_load_comp")                -> {"npc.is_load_comp",               async};
%% @todo q.npc.run_fast
%% @todo npc.run_xz_fast
%% @todo q.npc.walk_fast
%% @todo npc.walk_xz_fast
%% @todo obj.chair_disable
%% @todo obj.chair_enable
function("obj.get_eventflag")               -> {"obj.get_eventflag",              async};
function("obj.set_caption")                 -> {"obj.set_caption",                async};
function("obj.vehicle_resetpos")            -> {"obj.vehicle_resetpos",           async};
function("player.display")                  -> {"player.display",                 async};
function("player.disp_off_except_party")    -> {"player.disp_off_except_party",   async};
function("player.disp_on_except_party")     -> {"player.disp_on_except_party",    async};
function("player.face_set")                 -> {"player.face_set",                async};
%% @todo player.gaze_body
%% @todo player.get_action
function("player.get_level")                -> {"player.get_level",               async};
function("player.get_my_pmid")              -> {"q.player.get_my_pmid",           async};
function("player.get_occupation")           -> {"player.get_occupation",          async};
function("player.get_off_vehicle")          -> {"player.get_off_vehicle",         async};
%% @todo player.get_on_vehicle
function("player.get_race")                 -> {"player.get_race",                async};
function("player.get_sex")                  -> {"player.get_sex",                 async};
function("player.hide")                     -> {"player.hide",                    async};
function("player.is_dead")                  -> {"player.is_dead",                 async};
%% @todo player.is_equipping_item
function("player.is_in_sp")                 -> {"player.is_in_sp",                async};
function("player.is_on_vehicle")            -> {"player.is_on_vehicle",           async};
%% @todo player.move
%% @todo player.move_xz
%% @todo player.set_vehicle_breakpos
function("player.sp_cancel")                -> {"player.sp_cancel",               async};
%% @todo player.turn_round
%% @todo player.turn_round_coord_xz
function("plymotion.can_i_set_event_pack")  -> {"plymotion.can_i_set_event_pack", async};
%% @todo plymotion.get_pack
function("plymotion.is_ready")              -> {"plymotion.is_ready",             async};
function("plymotion.item_re_equip")         -> {"plymotion.item_re_equip",        async};
%% @todo radar.display
%% @todo radar.fullclose
function("radar.fullopen")                  -> {"radar.fullopen",                 async};
%% @todo radar.hide
function("seq.endroll_play")                -> {"q.seq.endroll_play",              sync};
%% @todo seq.get_death_count
%% @todo seq.get_death_count_apc
function("seq.get_destroy_enemy_count")     -> {"seq.get_destroy_enemy_count",    async};
function("seq.get_elapsed_time")            -> {"seq.get_elapsed_time",           async};
function("seq.get_judgement")               -> {"seq.get_judgement",              async};
function("seq.get_mission_step")            -> {"seq.get_mission_step",           async};
function("seq.get_rank")                    -> {"seq.get_rank",                   async};
%% @todo seq.get_remaining_time
%% @todo seq.get_setdata_inx
%% @todo seq.goto_title
function("seq.has_finished_result")         -> {"seq.has_finished_result",        async};
function("seq.open_ex_mode")                -> {"seq.open_ex_mode",               async};
function("seq.preview_network")             -> {"q.seq.preview_network",           sync};
function("seq.preview_play")                -> {"q.seq.preview_play",              sync};
function("seq.result")                      -> {"q.seq.result",                   async};
function("seq.save_menu")                   -> {"q.seq.save_menu",                 sync};
%% @todo seq.set_chapter_no
function("seq.set_ex_chapter_no")           -> {"seq.set_ex_chapter_no",          async};
%% @todo seq.set_story_end_flag
function("seq.staffroll_play")              -> {"q.seq.staffroll_play",            sync};
%% @todo q.seq.unify_counter
function("shop.open")                       -> {"shop.open",                      async};
%% @todo shop.req_load_data
function("sjis.line_window_time")           -> {"q.sjis.line_window_time",        async};
function("sound.check_jingle")              -> {"sound.check_jingle",             async};
%% @todo sound.get_player_pack
function("sound.load_enemy_pack")           -> {"sound.load_enemy_pack",          async};
%% @todo sound.load_enemy_port_pack
function("sound.load_event_pack")           -> {"sound.load_event_pack",          async};
function("sound.load_player_pack")          -> {"sound.load_player_pack",         async};
%% @todo sound.pause_adx_voice
function("sound.pause_bgm")                 -> {"sound.pause_bgm",                async};
function("sound.play_jingle")               -> {"sound.play_jingle",              async};
function("sound.play_se3d_loop_stop")       -> {"sound.play_se3d_loop_stop",      async};
function("sound.play_se3d_loop_vol")        -> {"sound.play_se3d_loop_vol",       async};
function("sound.play_player")               -> {"q.sound.play_player",             sync};
function("sound.play_se3d")                 -> {"q.sound.play_se3d",               sync};
%% @todo sound.play_se3d_loop
function("sound.play_se3d_vol")             -> {"q.sound.play_se3d_vol",           sync};
function("sound.play_technique")            -> {"sound.play_technique",           async};
function("sound.play_vehicle")              -> {"sound.play_vehicle",             async};
function("sound.stop_adx_voice")            -> {"sound.stop_adx_voice",           async};
function("system.frame_adjust")             -> {"system.frame_adjust",            async};
%% @todo system.frame_default
function("system.frame_get")                -> {"system.frame_get",               async};
%% @todo system.frame_set
function("system.get_episode")              -> {"system.get_episode",             async};
%% @todo system.get_language
function("system.get_platform")             -> {"system.get_platform",            async};
function("system.get_resolution")           -> {"system.get_resolution",          async};
function("work.get_stamp_bonus")            -> {"q.work.get_stamp_bonus",          sync};
function("work.get_stamp_num")              -> {"q.work.get_stamp_num",            sync};
function("work.get_stamp_quest")            -> {"q.work.get_stamp_quest",          sync};
%% @todo q.work.on_accountwork_get
function("work.partyworknum_get")           -> {"q.work.partyworknum_get",        async};
function("work.partyworknum_set")           -> {"q.work.partyworknum_set",        async};
%% @todo q.work.stamp_command
function(Name)                              -> {Name,                             local}.

%% Strings.
string_gen([$\\|Cs]) ->
	string_escape(Cs);
string_gen([C|Cs]) ->
	[C|string_gen(Cs)];
string_gen([]) ->
	[].

string_escape([O1,O2,O3|S]) when O1 >= $0, O1 =< $7, O2 >= $0, O2 =< $7, O3 >= $0, O3 =< $7 ->
	[(O1*8 + O2)*8 + O3 - 73*$0|string_gen(S)];
string_escape([$^,C|Cs]) ->
	[C band 31|string_gen(Cs)];
string_escape([C|Cs]) when C >= $\000, C =< $\s ->
	string_gen(Cs);
string_escape([C|Cs]) ->
	[escape_char(C)|string_gen(Cs)].

escape_char($n) -> $\n; %% \n = LF
escape_char($r) -> $\r; %% \r = CR
escape_char($t) -> $\t; %% \t = TAB
escape_char($v) -> $\v; %% \v = VT
escape_char($b) -> $\b; %% \b = BS
escape_char($f) -> $\f; %% \f = FF
escape_char($e) -> $\e; %% \e = ESC
escape_char($s) -> $\s; %% \s = SPC
escape_char($d) -> $\d; %% \d = DEL
escape_char(C) -> C.

-file("/usr/lib/erlang/lib/parsetools-2.0.6/include/leexinc.hrl", 14).

format_error({illegal,S}) -> ["illegal characters ",io_lib:write_string(S)];
format_error({user,S}) -> S.

string(String) -> string(String, 1).

string(String, Line) -> string(String, Line, String, []).

%% string(InChars, Line, TokenChars, Tokens) ->
%% {ok,Tokens,Line} | {error,ErrorInfo,Line}.
%% Note the line number going into yystate, L0, is line of token
%% start while line number returned is line of token end. We want line
%% of token start.

string([], L, [], Ts) ->                     % No partial tokens!
    {ok,yyrev(Ts),L};
string(Ics0, L0, Tcs, Ts) ->
    case yystate(yystate(), Ics0, L0, 0, reject, 0) of
        {A,Alen,Ics1,L1} ->                  % Accepting end state
            string_cont(Ics1, L1, yyaction(A, Alen, Tcs, L0), Ts);
        {A,Alen,Ics1,L1,_S1} ->              % Accepting transistion state
            string_cont(Ics1, L1, yyaction(A, Alen, Tcs, L0), Ts);
        {reject,_Alen,Tlen,_Ics1,L1,_S1} ->  % After a non-accepting state
            {error,{L0,?MODULE,{illegal,yypre(Tcs, Tlen+1)}},L1};
        {A,Alen,_Tlen,_Ics1,L1,_S1} ->
            string_cont(yysuf(Tcs, Alen), L1, yyaction(A, Alen, Tcs, L0), Ts)
    end.

%% string_cont(RestChars, Line, Token, Tokens)
%% Test for and remove the end token wrapper. Push back characters
%% are prepended to RestChars.

string_cont(Rest, Line, {token,T}, Ts) ->
    string(Rest, Line, Rest, [T|Ts]);
string_cont(Rest, Line, {token,T,Push}, Ts) ->
    NewRest = Push ++ Rest,
    string(NewRest, Line, NewRest, [T|Ts]);
string_cont(Rest, Line, {end_token,T}, Ts) ->
    string(Rest, Line, Rest, [T|Ts]);
string_cont(Rest, Line, {end_token,T,Push}, Ts) ->
    NewRest = Push ++ Rest,
    string(NewRest, Line, NewRest, [T|Ts]);
string_cont(Rest, Line, skip_token, Ts) ->
    string(Rest, Line, Rest, Ts);
string_cont(Rest, Line, {skip_token,Push}, Ts) ->
    NewRest = Push ++ Rest,
    string(NewRest, Line, NewRest, Ts);
string_cont(_Rest, Line, {error,S}, _Ts) ->
    {error,{Line,?MODULE,{user,S}},Line}.

%% token(Continuation, Chars) ->
%% token(Continuation, Chars, Line) ->
%% {more,Continuation} | {done,ReturnVal,RestChars}.
%% Must be careful when re-entering to append the latest characters to the
%% after characters in an accept. The continuation is:
%% {token,State,CurrLine,TokenChars,TokenLen,TokenLine,AccAction,AccLen}

token(Cont, Chars) -> token(Cont, Chars, 1).

token([], Chars, Line) ->
    token(yystate(), Chars, Line, Chars, 0, Line, reject, 0);
token({token,State,Line,Tcs,Tlen,Tline,Action,Alen}, Chars, _) ->
    token(State, Chars, Line, Tcs ++ Chars, Tlen, Tline, Action, Alen).

%% token(State, InChars, Line, TokenChars, TokenLen, TokenLine,
%% AcceptAction, AcceptLen) ->
%% {more,Continuation} | {done,ReturnVal,RestChars}.
%% The argument order is chosen to be more efficient.

token(S0, Ics0, L0, Tcs, Tlen0, Tline, A0, Alen0) ->
    case yystate(S0, Ics0, L0, Tlen0, A0, Alen0) of
        %% Accepting end state, we have a token.
        {A1,Alen1,Ics1,L1} ->
            token_cont(Ics1, L1, yyaction(A1, Alen1, Tcs, Tline));
        %% Accepting transition state, can take more chars.
        {A1,Alen1,[],L1,S1} ->                  % Need more chars to check
            {more,{token,S1,L1,Tcs,Alen1,Tline,A1,Alen1}};
        {A1,Alen1,Ics1,L1,_S1} ->               % Take what we got
            token_cont(Ics1, L1, yyaction(A1, Alen1, Tcs, Tline));
        %% After a non-accepting state, maybe reach accept state later.
        {A1,Alen1,Tlen1,[],L1,S1} ->            % Need more chars to check
            {more,{token,S1,L1,Tcs,Tlen1,Tline,A1,Alen1}};
        {reject,_Alen1,Tlen1,eof,L1,_S1} ->     % No token match
            %% Check for partial token which is error.
            Ret = if Tlen1 > 0 -> {error,{Tline,?MODULE,
                                          %% Skip eof tail in Tcs.
                                          {illegal,yypre(Tcs, Tlen1)}},L1};
                     true -> {eof,L1}
                  end,
            {done,Ret,eof};
        {reject,_Alen1,Tlen1,Ics1,L1,_S1} ->    % No token match
            Error = {Tline,?MODULE,{illegal,yypre(Tcs, Tlen1+1)}},
            {done,{error,Error,L1},Ics1};
        {A1,Alen1,_Tlen1,_Ics1,L1,_S1} ->       % Use last accept match
            token_cont(yysuf(Tcs, Alen1), L1, yyaction(A1, Alen1, Tcs, Tline))
    end.

%% token_cont(RestChars, Line, Token)
%% If we have a token or error then return done, else if we have a
%% skip_token then continue.

token_cont(Rest, Line, {token,T}) ->
    {done,{ok,T,Line},Rest};
token_cont(Rest, Line, {token,T,Push}) ->
    NewRest = Push ++ Rest,
    {done,{ok,T,Line},NewRest};
token_cont(Rest, Line, {end_token,T}) ->
    {done,{ok,T,Line},Rest};
token_cont(Rest, Line, {end_token,T,Push}) ->
    NewRest = Push ++ Rest,
    {done,{ok,T,Line},NewRest};
token_cont(Rest, Line, skip_token) ->
    token(yystate(), Rest, Line, Rest, 0, Line, reject, 0);
token_cont(Rest, Line, {skip_token,Push}) ->
    NewRest = Push ++ Rest,
    token(yystate(), NewRest, Line, NewRest, 0, Line, reject, 0);
token_cont(Rest, Line, {error,S}) ->
    {done,{error,{Line,?MODULE,{user,S}},Line},Rest}.

%% tokens(Continuation, Chars, Line) ->
%% {more,Continuation} | {done,ReturnVal,RestChars}.
%% Must be careful when re-entering to append the latest characters to the
%% after characters in an accept. The continuation is:
%% {tokens,State,CurrLine,TokenChars,TokenLen,TokenLine,Tokens,AccAction,AccLen}
%% {skip_tokens,State,CurrLine,TokenChars,TokenLen,TokenLine,Error,AccAction,AccLen}

tokens(Cont, Chars) -> tokens(Cont, Chars, 1).

tokens([], Chars, Line) ->
    tokens(yystate(), Chars, Line, Chars, 0, Line, [], reject, 0);
tokens({tokens,State,Line,Tcs,Tlen,Tline,Ts,Action,Alen}, Chars, _) ->
    tokens(State, Chars, Line, Tcs ++ Chars, Tlen, Tline, Ts, Action, Alen);
tokens({skip_tokens,State,Line,Tcs,Tlen,Tline,Error,Action,Alen}, Chars, _) ->
    skip_tokens(State, Chars, Line, Tcs ++ Chars, Tlen, Tline, Error, Action, Alen).

%% tokens(State, InChars, Line, TokenChars, TokenLen, TokenLine, Tokens,
%% AcceptAction, AcceptLen) ->
%% {more,Continuation} | {done,ReturnVal,RestChars}.

tokens(S0, Ics0, L0, Tcs, Tlen0, Tline, Ts, A0, Alen0) ->
    case yystate(S0, Ics0, L0, Tlen0, A0, Alen0) of
        %% Accepting end state, we have a token.
        {A1,Alen1,Ics1,L1} ->
            tokens_cont(Ics1, L1, yyaction(A1, Alen1, Tcs, Tline), Ts);
        %% Accepting transition state, can take more chars.
        {A1,Alen1,[],L1,S1} ->                  % Need more chars to check
            {more,{tokens,S1,L1,Tcs,Alen1,Tline,Ts,A1,Alen1}};
        {A1,Alen1,Ics1,L1,_S1} ->               % Take what we got
            tokens_cont(Ics1, L1, yyaction(A1, Alen1, Tcs, Tline), Ts);
        %% After a non-accepting state, maybe reach accept state later.
        {A1,Alen1,Tlen1,[],L1,S1} ->            % Need more chars to check
            {more,{tokens,S1,L1,Tcs,Tlen1,Tline,Ts,A1,Alen1}};
        {reject,_Alen1,Tlen1,eof,L1,_S1} ->     % No token match
            %% Check for partial token which is error, no need to skip here.
            Ret = if Tlen1 > 0 -> {error,{Tline,?MODULE,
                                          %% Skip eof tail in Tcs.
                                          {illegal,yypre(Tcs, Tlen1)}},L1};
                     Ts == [] -> {eof,L1};
                     true -> {ok,yyrev(Ts),L1}
                  end,
            {done,Ret,eof};
        {reject,_Alen1,Tlen1,_Ics1,L1,_S1} ->
            %% Skip rest of tokens.
            Error = {L1,?MODULE,{illegal,yypre(Tcs, Tlen1+1)}},
            skip_tokens(yysuf(Tcs, Tlen1+1), L1, Error);
        {A1,Alen1,_Tlen1,_Ics1,L1,_S1} ->
            Token = yyaction(A1, Alen1, Tcs, Tline),
            tokens_cont(yysuf(Tcs, Alen1), L1, Token, Ts)
    end.

%% tokens_cont(RestChars, Line, Token, Tokens)
%% If we have an end_token or error then return done, else if we have
%% a token then save it and continue, else if we have a skip_token
%% just continue.

tokens_cont(Rest, Line, {token,T}, Ts) ->
    tokens(yystate(), Rest, Line, Rest, 0, Line, [T|Ts], reject, 0);
tokens_cont(Rest, Line, {token,T,Push}, Ts) ->
    NewRest = Push ++ Rest,
    tokens(yystate(), NewRest, Line, NewRest, 0, Line, [T|Ts], reject, 0);
tokens_cont(Rest, Line, {end_token,T}, Ts) ->
    {done,{ok,yyrev(Ts, [T]),Line},Rest};
tokens_cont(Rest, Line, {end_token,T,Push}, Ts) ->
    NewRest = Push ++ Rest,
    {done,{ok,yyrev(Ts, [T]),Line},NewRest};
tokens_cont(Rest, Line, skip_token, Ts) ->
    tokens(yystate(), Rest, Line, Rest, 0, Line, Ts, reject, 0);
tokens_cont(Rest, Line, {skip_token,Push}, Ts) ->
    NewRest = Push ++ Rest,
    tokens(yystate(), NewRest, Line, NewRest, 0, Line, Ts, reject, 0);
tokens_cont(Rest, Line, {error,S}, _Ts) ->
    skip_tokens(Rest, Line, {Line,?MODULE,{user,S}}).

%%skip_tokens(InChars, Line, Error) -> {done,{error,Error,Line},Ics}.
%% Skip tokens until an end token, junk everything and return the error.

skip_tokens(Ics, Line, Error) ->
    skip_tokens(yystate(), Ics, Line, Ics, 0, Line, Error, reject, 0).

%% skip_tokens(State, InChars, Line, TokenChars, TokenLen, TokenLine, Tokens,
%% AcceptAction, AcceptLen) ->
%% {more,Continuation} | {done,ReturnVal,RestChars}.

skip_tokens(S0, Ics0, L0, Tcs, Tlen0, Tline, Error, A0, Alen0) ->
    case yystate(S0, Ics0, L0, Tlen0, A0, Alen0) of
        {A1,Alen1,Ics1,L1} ->                  % Accepting end state
            skip_cont(Ics1, L1, yyaction(A1, Alen1, Tcs, Tline), Error);
        {A1,Alen1,[],L1,S1} ->                 % After an accepting state
            {more,{skip_tokens,S1,L1,Tcs,Alen1,Tline,Error,A1,Alen1}};
        {A1,Alen1,Ics1,L1,_S1} ->
            skip_cont(Ics1, L1, yyaction(A1, Alen1, Tcs, Tline), Error);
        {A1,Alen1,Tlen1,[],L1,S1} ->           % After a non-accepting state
            {more,{skip_tokens,S1,L1,Tcs,Tlen1,Tline,Error,A1,Alen1}};
        {reject,_Alen1,_Tlen1,eof,L1,_S1} ->
            {done,{error,Error,L1},eof};
        {reject,_Alen1,Tlen1,_Ics1,L1,_S1} ->
            skip_tokens(yysuf(Tcs, Tlen1+1), L1, Error);
        {A1,Alen1,_Tlen1,_Ics1,L1,_S1} ->
            Token = yyaction(A1, Alen1, Tcs, Tline),
            skip_cont(yysuf(Tcs, Alen1), L1, Token, Error)
    end.

%% skip_cont(RestChars, Line, Token, Error)
%% Skip tokens until we have an end_token or error then return done
%% with the original rror.

skip_cont(Rest, Line, {token,_T}, Error) ->
    skip_tokens(yystate(), Rest, Line, Rest, 0, Line, Error, reject, 0);
skip_cont(Rest, Line, {token,_T,Push}, Error) ->
    NewRest = Push ++ Rest,
    skip_tokens(yystate(), NewRest, Line, NewRest, 0, Line, Error, reject, 0);
skip_cont(Rest, Line, {end_token,_T}, Error) ->
    {done,{error,Error,Line},Rest};
skip_cont(Rest, Line, {end_token,_T,Push}, Error) ->
    NewRest = Push ++ Rest,
    {done,{error,Error,Line},NewRest};
skip_cont(Rest, Line, skip_token, Error) ->
    skip_tokens(yystate(), Rest, Line, Rest, 0, Line, Error, reject, 0);
skip_cont(Rest, Line, {skip_token,Push}, Error) ->
    NewRest = Push ++ Rest,
    skip_tokens(yystate(), NewRest, Line, NewRest, 0, Line, Error, reject, 0);
skip_cont(Rest, Line, {error,_S}, Error) ->
    skip_tokens(yystate(), Rest, Line, Rest, 0, Line, Error, reject, 0).

yyrev(List) -> lists:reverse(List).
yyrev(List, Tail) -> lists:reverse(List, Tail).
yypre(List, N) -> lists:sublist(List, N).
yysuf(List, N) -> lists:nthtail(N, List).

%% yystate() -> InitialState.
%% yystate(State, InChars, Line, CurrTokLen, AcceptAction, AcceptLen) ->
%% {Action, AcceptLen, RestChars, Line} |
%% {Action, AcceptLen, RestChars, Line, State} |
%% {reject, AcceptLen, CurrTokLen, RestChars, Line, State} |
%% {Action, AcceptLen, CurrTokLen, RestChars, Line, State}.
%% Generated state transition functions. The non-accepting end state
%% return signal either an unrecognised character or end of current
%% input.

-file("src/egs_script_lexer.erl", 739).
yystate() -> 21.

yystate(24, Ics, Line, Tlen, _, _) ->
    {4,Tlen,Ics,Line};
yystate(23, [37|Ics], Line, Tlen, _, _) ->
    yystate(0, Ics, Line, Tlen+1, 7, Tlen);
yystate(23, [10|Ics], Line, Tlen, _, _) ->
    yystate(23, Ics, Line+1, Tlen+1, 7, Tlen);
yystate(23, [C|Ics], Line, Tlen, _, _) when C >= 0, C =< 9 ->
    yystate(23, Ics, Line, Tlen+1, 7, Tlen);
yystate(23, [C|Ics], Line, Tlen, _, _) when C >= 11, C =< 32 ->
    yystate(23, Ics, Line, Tlen+1, 7, Tlen);
yystate(23, Ics, Line, Tlen, _, _) ->
    {7,Tlen,Ics,Line,23};
yystate(22, [62|Ics], Line, Tlen, Action, Alen) ->
    yystate(24, Ics, Line, Tlen+1, Action, Alen);
yystate(22, [45|Ics], Line, Tlen, Action, Alen) ->
    yystate(8, Ics, Line, Tlen+1, Action, Alen);
yystate(22, [C|Ics], Line, Tlen, Action, Alen) when C >= 48, C =< 57 ->
    yystate(20, Ics, Line, Tlen+1, Action, Alen);
yystate(22, Ics, Line, Tlen, Action, Alen) ->
    {Action,Alen,Tlen,Ics,Line,22};
yystate(21, [125|Ics], Line, Tlen, Action, Alen) ->
    yystate(4, Ics, Line, Tlen+1, Action, Alen);
yystate(21, [123|Ics], Line, Tlen, Action, Alen) ->
    yystate(4, Ics, Line, Tlen+1, Action, Alen);
yystate(21, [95|Ics], Line, Tlen, Action, Alen) ->
    yystate(17, Ics, Line, Tlen+1, Action, Alen);
yystate(21, [59|Ics], Line, Tlen, Action, Alen) ->
    yystate(4, Ics, Line, Tlen+1, Action, Alen);
yystate(21, [46|Ics], Line, Tlen, Action, Alen) ->
    yystate(10, Ics, Line, Tlen+1, Action, Alen);
yystate(21, [45|Ics], Line, Tlen, Action, Alen) ->
    yystate(22, Ics, Line, Tlen+1, Action, Alen);
yystate(21, [44|Ics], Line, Tlen, Action, Alen) ->
    yystate(4, Ics, Line, Tlen+1, Action, Alen);
yystate(21, [37|Ics], Line, Tlen, Action, Alen) ->
    yystate(0, Ics, Line, Tlen+1, Action, Alen);
yystate(21, [34|Ics], Line, Tlen, Action, Alen) ->
    yystate(19, Ics, Line, Tlen+1, Action, Alen);
yystate(21, [10|Ics], Line, Tlen, Action, Alen) ->
    yystate(23, Ics, Line+1, Tlen+1, Action, Alen);
yystate(21, [C|Ics], Line, Tlen, Action, Alen) when C >= 0, C =< 9 ->
    yystate(23, Ics, Line, Tlen+1, Action, Alen);
yystate(21, [C|Ics], Line, Tlen, Action, Alen) when C >= 11, C =< 32 ->
    yystate(23, Ics, Line, Tlen+1, Action, Alen);
yystate(21, [C|Ics], Line, Tlen, Action, Alen) when C >= 48, C =< 57 ->
    yystate(1, Ics, Line, Tlen+1, Action, Alen);
yystate(21, [C|Ics], Line, Tlen, Action, Alen) when C >= 65, C =< 90 ->
    yystate(17, Ics, Line, Tlen+1, Action, Alen);
yystate(21, [C|Ics], Line, Tlen, Action, Alen) when C >= 97, C =< 122 ->
    yystate(17, Ics, Line, Tlen+1, Action, Alen);
yystate(21, Ics, Line, Tlen, Action, Alen) ->
    {Action,Alen,Tlen,Ics,Line,21};
yystate(20, [46|Ics], Line, Tlen, _, _) ->
    yystate(16, Ics, Line, Tlen+1, 0, Tlen);
yystate(20, [C|Ics], Line, Tlen, _, _) when C >= 48, C =< 57 ->
    yystate(20, Ics, Line, Tlen+1, 0, Tlen);
yystate(20, Ics, Line, Tlen, _, _) ->
    {0,Tlen,Ics,Line,20};
yystate(19, [92|Ics], Line, Tlen, Action, Alen) ->
    yystate(7, Ics, Line, Tlen+1, Action, Alen);
yystate(19, [34|Ics], Line, Tlen, Action, Alen) ->
    yystate(15, Ics, Line, Tlen+1, Action, Alen);
yystate(19, [10|Ics], Line, Tlen, Action, Alen) ->
    yystate(19, Ics, Line+1, Tlen+1, Action, Alen);
yystate(19, [C|Ics], Line, Tlen, Action, Alen) when C >= 0, C =< 9 ->
    yystate(19, Ics, Line, Tlen+1, Action, Alen);
yystate(19, [C|Ics], Line, Tlen, Action, Alen) when C >= 11, C =< 33 ->
    yystate(19, Ics, Line, Tlen+1, Action, Alen);
yystate(19, [C|Ics], Line, Tlen, Action, Alen) when C >= 35, C =< 91 ->
    yystate(19, Ics, Line, Tlen+1, Action, Alen);
yystate(19, [C|Ics], Line, Tlen, Action, Alen) when C >= 93 ->
    yystate(19, Ics, Line, Tlen+1, Action, Alen);
yystate(19, Ics, Line, Tlen, Action, Alen) ->
    {Action,Alen,Tlen,Ics,Line,19};
yystate(18, Ics, Line, Tlen, _, _) ->
    {6,Tlen,Ics,Line};
yystate(17, [95|Ics], Line, Tlen, Action, Alen) ->
    yystate(13, Ics, Line, Tlen+1, Action, Alen);
yystate(17, [46|Ics], Line, Tlen, Action, Alen) ->
    yystate(9, Ics, Line, Tlen+1, Action, Alen);
yystate(17, [C|Ics], Line, Tlen, Action, Alen) when C >= 48, C =< 57 ->
    yystate(13, Ics, Line, Tlen+1, Action, Alen);
yystate(17, [C|Ics], Line, Tlen, Action, Alen) when C >= 65, C =< 90 ->
    yystate(13, Ics, Line, Tlen+1, Action, Alen);
yystate(17, [C|Ics], Line, Tlen, Action, Alen) when C >= 97, C =< 122 ->
    yystate(13, Ics, Line, Tlen+1, Action, Alen);
yystate(17, Ics, Line, Tlen, Action, Alen) ->
    {Action,Alen,Tlen,Ics,Line,17};
yystate(16, [C|Ics], Line, Tlen, Action, Alen) when C >= 48, C =< 57 ->
    yystate(12, Ics, Line, Tlen+1, Action, Alen);
yystate(16, Ics, Line, Tlen, Action, Alen) ->
    {Action,Alen,Tlen,Ics,Line,16};
yystate(15, Ics, Line, Tlen, _, _) ->
    {3,Tlen,Ics,Line};
yystate(14, [C|Ics], Line, Tlen, _, _) when C >= 0, C =< 9 ->
    yystate(14, Ics, Line, Tlen+1, 6, Tlen);
yystate(14, [C|Ics], Line, Tlen, _, _) when C >= 11 ->
    yystate(14, Ics, Line, Tlen+1, 6, Tlen);
yystate(14, Ics, Line, Tlen, _, _) ->
    {6,Tlen,Ics,Line,14};
yystate(13, [95|Ics], Line, Tlen, _, _) ->
    yystate(13, Ics, Line, Tlen+1, 2, Tlen);
yystate(13, [46|Ics], Line, Tlen, _, _) ->
    yystate(9, Ics, Line, Tlen+1, 2, Tlen);
yystate(13, [C|Ics], Line, Tlen, _, _) when C >= 48, C =< 57 ->
    yystate(13, Ics, Line, Tlen+1, 2, Tlen);
yystate(13, [C|Ics], Line, Tlen, _, _) when C >= 65, C =< 90 ->
    yystate(13, Ics, Line, Tlen+1, 2, Tlen);
yystate(13, [C|Ics], Line, Tlen, _, _) when C >= 97, C =< 122 ->
    yystate(13, Ics, Line, Tlen+1, 2, Tlen);
yystate(13, Ics, Line, Tlen, _, _) ->
    {2,Tlen,Ics,Line,13};
yystate(12, [C|Ics], Line, Tlen, _, _) when C >= 48, C =< 57 ->
    yystate(12, Ics, Line, Tlen+1, 1, Tlen);
yystate(12, Ics, Line, Tlen, _, _) ->
    {1,Tlen,Ics,Line,12};
yystate(11, [92|Ics], Line, Tlen, _, _) ->
    yystate(7, Ics, Line, Tlen+1, 3, Tlen);
yystate(11, [34|Ics], Line, Tlen, _, _) ->
    yystate(15, Ics, Line, Tlen+1, 3, Tlen);
yystate(11, [10|Ics], Line, Tlen, _, _) ->
    yystate(19, Ics, Line+1, Tlen+1, 3, Tlen);
yystate(11, [C|Ics], Line, Tlen, _, _) when C >= 0, C =< 9 ->
    yystate(19, Ics, Line, Tlen+1, 3, Tlen);
yystate(11, [C|Ics], Line, Tlen, _, _) when C >= 11, C =< 33 ->
    yystate(19, Ics, Line, Tlen+1, 3, Tlen);
yystate(11, [C|Ics], Line, Tlen, _, _) when C >= 35, C =< 91 ->
    yystate(19, Ics, Line, Tlen+1, 3, Tlen);
yystate(11, [C|Ics], Line, Tlen, _, _) when C >= 93 ->
    yystate(19, Ics, Line, Tlen+1, 3, Tlen);
yystate(11, Ics, Line, Tlen, _, _) ->
    {3,Tlen,Ics,Line,11};
yystate(10, [37|Ics], Line, Tlen, Action, Alen) ->
    yystate(14, Ics, Line, Tlen+1, Action, Alen);
yystate(10, [10|Ics], Line, Tlen, Action, Alen) ->
    yystate(18, Ics, Line+1, Tlen+1, Action, Alen);
yystate(10, [C|Ics], Line, Tlen, Action, Alen) when C >= 0, C =< 9 ->
    yystate(18, Ics, Line, Tlen+1, Action, Alen);
yystate(10, [C|Ics], Line, Tlen, Action, Alen) when C >= 11, C =< 32 ->
    yystate(18, Ics, Line, Tlen+1, Action, Alen);
yystate(10, Ics, Line, Tlen, Action, Alen) ->
    {Action,Alen,Tlen,Ics,Line,10};
yystate(9, [95|Ics], Line, Tlen, Action, Alen) ->
    yystate(5, Ics, Line, Tlen+1, Action, Alen);
yystate(9, [46|Ics], Line, Tlen, Action, Alen) ->
    yystate(9, Ics, Line, Tlen+1, Action, Alen);
yystate(9, [C|Ics], Line, Tlen, Action, Alen) when C >= 48, C =< 57 ->
    yystate(5, Ics, Line, Tlen+1, Action, Alen);
yystate(9, [C|Ics], Line, Tlen, Action, Alen) when C >= 65, C =< 90 ->
    yystate(5, Ics, Line, Tlen+1, Action, Alen);
yystate(9, [C|Ics], Line, Tlen, Action, Alen) when C >= 97, C =< 122 ->
    yystate(5, Ics, Line, Tlen+1, Action, Alen);
yystate(9, Ics, Line, Tlen, Action, Alen) ->
    {Action,Alen,Tlen,Ics,Line,9};
yystate(8, [45|Ics], Line, Tlen, Action, Alen) ->
    yystate(8, Ics, Line, Tlen+1, Action, Alen);
yystate(8, [C|Ics], Line, Tlen, Action, Alen) when C >= 48, C =< 57 ->
    yystate(20, Ics, Line, Tlen+1, Action, Alen);
yystate(8, Ics, Line, Tlen, Action, Alen) ->
    {Action,Alen,Tlen,Ics,Line,8};
yystate(7, [94|Ics], Line, Tlen, Action, Alen) ->
    yystate(3, Ics, Line, Tlen+1, Action, Alen);
yystate(7, [93|Ics], Line, Tlen, Action, Alen) ->
    yystate(19, Ics, Line, Tlen+1, Action, Alen);
yystate(7, [92|Ics], Line, Tlen, Action, Alen) ->
    yystate(7, Ics, Line, Tlen+1, Action, Alen);
yystate(7, [34|Ics], Line, Tlen, Action, Alen) ->
    yystate(11, Ics, Line, Tlen+1, Action, Alen);
yystate(7, [10|Ics], Line, Tlen, Action, Alen) ->
    yystate(19, Ics, Line+1, Tlen+1, Action, Alen);
yystate(7, [C|Ics], Line, Tlen, Action, Alen) when C >= 0, C =< 9 ->
    yystate(19, Ics, Line, Tlen+1, Action, Alen);
yystate(7, [C|Ics], Line, Tlen, Action, Alen) when C >= 11, C =< 33 ->
    yystate(19, Ics, Line, Tlen+1, Action, Alen);
yystate(7, [C|Ics], Line, Tlen, Action, Alen) when C >= 35, C =< 91 ->
    yystate(19, Ics, Line, Tlen+1, Action, Alen);
yystate(7, [C|Ics], Line, Tlen, Action, Alen) when C >= 95 ->
    yystate(19, Ics, Line, Tlen+1, Action, Alen);
yystate(7, Ics, Line, Tlen, Action, Alen) ->
    {Action,Alen,Tlen,Ics,Line,7};
yystate(6, [95|Ics], Line, Tlen, _, _) ->
    yystate(5, Ics, Line, Tlen+1, 1, Tlen);
yystate(6, [C|Ics], Line, Tlen, _, _) when C >= 48, C =< 57 ->
    yystate(6, Ics, Line, Tlen+1, 1, Tlen);
yystate(6, [C|Ics], Line, Tlen, _, _) when C >= 65, C =< 90 ->
    yystate(5, Ics, Line, Tlen+1, 1, Tlen);
yystate(6, [C|Ics], Line, Tlen, _, _) when C >= 97, C =< 122 ->
    yystate(5, Ics, Line, Tlen+1, 1, Tlen);
yystate(6, Ics, Line, Tlen, _, _) ->
    {1,Tlen,Ics,Line,6};
yystate(5, [95|Ics], Line, Tlen, _, _) ->
    yystate(5, Ics, Line, Tlen+1, 2, Tlen);
yystate(5, [C|Ics], Line, Tlen, _, _) when C >= 48, C =< 57 ->
    yystate(5, Ics, Line, Tlen+1, 2, Tlen);
yystate(5, [C|Ics], Line, Tlen, _, _) when C >= 65, C =< 90 ->
    yystate(5, Ics, Line, Tlen+1, 2, Tlen);
yystate(5, [C|Ics], Line, Tlen, _, _) when C >= 97, C =< 122 ->
    yystate(5, Ics, Line, Tlen+1, 2, Tlen);
yystate(5, Ics, Line, Tlen, _, _) ->
    {2,Tlen,Ics,Line,5};
yystate(4, Ics, Line, Tlen, _, _) ->
    {5,Tlen,Ics,Line};
yystate(3, [92|Ics], Line, Tlen, Action, Alen) ->
    yystate(7, Ics, Line, Tlen+1, Action, Alen);
yystate(3, [34|Ics], Line, Tlen, Action, Alen) ->
    yystate(11, Ics, Line, Tlen+1, Action, Alen);
yystate(3, [10|Ics], Line, Tlen, Action, Alen) ->
    yystate(19, Ics, Line+1, Tlen+1, Action, Alen);
yystate(3, [C|Ics], Line, Tlen, Action, Alen) when C >= 0, C =< 9 ->
    yystate(19, Ics, Line, Tlen+1, Action, Alen);
yystate(3, [C|Ics], Line, Tlen, Action, Alen) when C >= 11, C =< 33 ->
    yystate(19, Ics, Line, Tlen+1, Action, Alen);
yystate(3, [C|Ics], Line, Tlen, Action, Alen) when C >= 35, C =< 91 ->
    yystate(19, Ics, Line, Tlen+1, Action, Alen);
yystate(3, [C|Ics], Line, Tlen, Action, Alen) when C >= 93 ->
    yystate(19, Ics, Line, Tlen+1, Action, Alen);
yystate(3, Ics, Line, Tlen, Action, Alen) ->
    {Action,Alen,Tlen,Ics,Line,3};
yystate(2, [95|Ics], Line, Tlen, Action, Alen) ->
    yystate(5, Ics, Line, Tlen+1, Action, Alen);
yystate(2, [46|Ics], Line, Tlen, Action, Alen) ->
    yystate(9, Ics, Line, Tlen+1, Action, Alen);
yystate(2, [C|Ics], Line, Tlen, Action, Alen) when C >= 48, C =< 57 ->
    yystate(6, Ics, Line, Tlen+1, Action, Alen);
yystate(2, [C|Ics], Line, Tlen, Action, Alen) when C >= 65, C =< 90 ->
    yystate(5, Ics, Line, Tlen+1, Action, Alen);
yystate(2, [C|Ics], Line, Tlen, Action, Alen) when C >= 97, C =< 122 ->
    yystate(5, Ics, Line, Tlen+1, Action, Alen);
yystate(2, Ics, Line, Tlen, Action, Alen) ->
    {Action,Alen,Tlen,Ics,Line,2};
yystate(1, [95|Ics], Line, Tlen, _, _) ->
    yystate(13, Ics, Line, Tlen+1, 0, Tlen);
yystate(1, [46|Ics], Line, Tlen, _, _) ->
    yystate(2, Ics, Line, Tlen+1, 0, Tlen);
yystate(1, [C|Ics], Line, Tlen, _, _) when C >= 48, C =< 57 ->
    yystate(1, Ics, Line, Tlen+1, 0, Tlen);
yystate(1, [C|Ics], Line, Tlen, _, _) when C >= 65, C =< 90 ->
    yystate(13, Ics, Line, Tlen+1, 0, Tlen);
yystate(1, [C|Ics], Line, Tlen, _, _) when C >= 97, C =< 122 ->
    yystate(13, Ics, Line, Tlen+1, 0, Tlen);
yystate(1, Ics, Line, Tlen, _, _) ->
    {0,Tlen,Ics,Line,1};
yystate(0, [37|Ics], Line, Tlen, _, _) ->
    yystate(0, Ics, Line, Tlen+1, 7, Tlen);
yystate(0, [10|Ics], Line, Tlen, _, _) ->
    yystate(23, Ics, Line+1, Tlen+1, 7, Tlen);
yystate(0, [C|Ics], Line, Tlen, _, _) when C >= 0, C =< 9 ->
    yystate(0, Ics, Line, Tlen+1, 7, Tlen);
yystate(0, [C|Ics], Line, Tlen, _, _) when C >= 11, C =< 32 ->
    yystate(0, Ics, Line, Tlen+1, 7, Tlen);
yystate(0, [C|Ics], Line, Tlen, _, _) when C >= 33, C =< 36 ->
    yystate(0, Ics, Line, Tlen+1, 7, Tlen);
yystate(0, [C|Ics], Line, Tlen, _, _) when C >= 38 ->
    yystate(0, Ics, Line, Tlen+1, 7, Tlen);
yystate(0, Ics, Line, Tlen, _, _) ->
    {7,Tlen,Ics,Line,0};
yystate(S, Ics, Line, Tlen, Action, Alen) ->
    {Action,Alen,Tlen,Ics,Line,S}.

%% yyaction(Action, TokenLength, TokenChars, TokenLine) ->
%% {token,Token} | {end_token, Token} | skip_token | {error,String}.
%% Generated action function.

yyaction(0, TokenLen, YYtcs, TokenLine) ->
    TokenChars = yypre(YYtcs, TokenLen),
    yyaction_0(TokenChars, TokenLine);
yyaction(1, TokenLen, YYtcs, TokenLine) ->
    TokenChars = yypre(YYtcs, TokenLen),
    yyaction_1(TokenChars, TokenLine);
yyaction(2, TokenLen, YYtcs, TokenLine) ->
    TokenChars = yypre(YYtcs, TokenLen),
    yyaction_2(TokenChars, TokenLine);
yyaction(3, TokenLen, YYtcs, TokenLine) ->
    TokenChars = yypre(YYtcs, TokenLen),
    yyaction_3(TokenChars, TokenLen, TokenLine);
yyaction(4, _, _, TokenLine) ->
    yyaction_4(TokenLine);
yyaction(5, TokenLen, YYtcs, TokenLine) ->
    TokenChars = yypre(YYtcs, TokenLen),
    yyaction_5(TokenChars, TokenLine);
yyaction(6, _, _, TokenLine) ->
    yyaction_6(TokenLine);
yyaction(7, _, _, _) ->
    yyaction_7();
yyaction(_, _, _, _) -> error.

-compile({inline,yyaction_0/2}).
-file("src/egs_script_lexer.xrl", 27).
yyaction_0(TokenChars, TokenLine) ->
     { token, { integer, TokenLine, list_to_integer (TokenChars) } } .

-compile({inline,yyaction_1/2}).
-file("src/egs_script_lexer.xrl", 28).
yyaction_1(TokenChars, TokenLine) ->
     { token, { float, TokenLine, list_to_float (TokenChars) } } .

-compile({inline,yyaction_2/2}).
-file("src/egs_script_lexer.xrl", 29).
yyaction_2(TokenChars, TokenLine) ->
     { token, case reserved_word (TokenChars) of
     false -> case syscall (TokenChars) of
     false -> { function, TokenLine, function (TokenChars) } ;
     Syscall -> { syscall, TokenLine, Syscall }
     end ;
     KeyWord -> { KeyWord, TokenLine }
     end } .

-compile({inline,yyaction_3/3}).
-file("src/egs_script_lexer.xrl", 37).
yyaction_3(TokenChars, TokenLen, TokenLine) ->
     S = lists : sublist (TokenChars, 2, TokenLen - 2),
     { token, { string, TokenLine, string_gen (S) } } .

-compile({inline,yyaction_4/1}).
-file("src/egs_script_lexer.xrl", 39).
yyaction_4(TokenLine) ->
     { token, { '->', TokenLine } } .

-compile({inline,yyaction_5/2}).
-file("src/egs_script_lexer.xrl", 40).
yyaction_5(TokenChars, TokenLine) ->
     { token, { list_to_atom (TokenChars), TokenLine } } .

-compile({inline,yyaction_6/1}).
-file("src/egs_script_lexer.xrl", 41).
yyaction_6(TokenLine) ->
     { end_token, { dot, TokenLine } } .

-compile({inline,yyaction_7/0}).
-file("src/egs_script_lexer.xrl", 42).
yyaction_7() ->
     skip_token .

-file("/usr/lib/erlang/lib/parsetools-2.0.6/include/leexinc.hrl", 282).
